Loading...
Searching...
No Matches
juce::ChildProcessCoordinator Class Reference

`#include <juce_ConnectedChildProcess.h>`

## Public Member Functions

| ChildProcessCoordinator ()
virtual | ~ChildProcessCoordinator ()
bool | launchWorkerProcess (const File &executableToLaunch, const String &commandLineUniqueID, int timeoutMs=0, int streamFlags=ChildProcess::wantStdOut|ChildProcess::wantStdErr)
bool | launchSlaveProcess (const File &executableToLaunch, const String &commandLineUniqueID, int timeoutMs=0, int streamFlags=ChildProcess::wantStdOut|ChildProcess::wantStdErr)
void | killWorkerProcess ()
void | killSlaveProcess ()
virtual void | handleMessageFromWorker (const MemoryBlock &)
virtual void | handleMessageFromSlave (const MemoryBlock &)
virtual void | handleConnectionLost ()
bool | sendMessageToWorker (const MemoryBlock &)
bool | sendMessageToSlave (const MemoryBlock &mb)

## Detailed Description

Acts as the coordinator in a coordinator/worker pair of connected processes.

The ChildProcessWorker and ChildProcessCoordinator classes make it easy for an app to spawn a child process, and to manage a 2-way messaging connection to control it.

To use the system, you need to create subclasses of both ChildProcessWorker and ChildProcessCoordinator. When you want your coordinator process to launch the worker, you just call launchWorkerProcess(), and it'll attempt to launch the executable that you specify (which may be the same exe), and assuming it has been set-up to correctly parse the command-line parameters (see ChildProcessWorker) then a two-way connection will be created.

The juce demo app has a good example of this class in action.

See also
  ChildProcessWorker, InterprocessConnection, ChildProcess

Definition at line 140 of file juce_ConnectedChildProcess.h.

## Constructor & Destructor Documentation

## ChildProcessCoordinator()

juce::ChildProcessCoordinator::ChildProcessCoordinator | ( |  | ) |

default

Creates an uninitialised coordinator process object. Use launchWorkerProcess to launch and connect to a child process.

Referenced by ChildProcessCoordinator().

## ~ChildProcessCoordinator()

juce::ChildProcessCoordinator::~ChildProcessCoordinator | ( |  | ) |

virtual

Destructor. Note that the destructor calls killWorkerProcess(), but doesn't wait for the child process to finish terminating.

Definition at line 131 of file juce_ConnectedChildProcess.cpp.

## Member Function Documentation

## handleConnectionLost()

void juce::ChildProcessCoordinator::handleConnectionLost | ( |  | ) |

virtual

This will be called when the worker process dies or is somehow disconnected. The call will probably be made on a background thread, so be careful with your thread-safety!

Definition at line 136 of file juce_ConnectedChildProcess.cpp.

## handleMessageFromSlave()

virtual void juce::ChildProcessCoordinator::handleMessageFromSlave | ( | const MemoryBlock & |  | ) |

inline virtual

Definition at line 200 of file juce_ConnectedChildProcess.h.

## handleMessageFromWorker()

void juce::ChildProcessCoordinator::handleMessageFromWorker | ( | const MemoryBlock & | mb | ) |

virtual

This will be called to deliver a message from the worker process. The call will probably be made on a background thread, so be careful with your thread-safety!

Definition at line 138 of file juce_ConnectedChildProcess.cpp.

## killSlaveProcess()

void juce::ChildProcessCoordinator::killSlaveProcess | ( |  | ) |

inline

Definition at line 192 of file juce_ConnectedChildProcess.h.

## killWorkerProcess()

void juce::ChildProcessCoordinator::killWorkerProcess | ( |  | ) |

Sends a kill message to the worker, and disconnects from it. Note that this won't wait for it to terminate.

Definition at line 197 of file juce_ConnectedChildProcess.cpp.

Referenced by launchWorkerProcess(), and ~ChildProcessCoordinator().

## launchSlaveProcess()

bool juce::ChildProcessCoordinator::launchSlaveProcess | ( | const File & | executableToLaunch,
|  | const String & | commandLineUniqueID,
|  | int | timeoutMs = 0,
|  | int | streamFlags = ChildProcess::wantStdOut | ChildProcess::wantStdErr )

inline

Definition at line 178 of file juce_ConnectedChildProcess.h.

## launchWorkerProcess()

bool juce::ChildProcessCoordinator::launchWorkerProcess | ( | const File & | executableToLaunch,
|  | const String & | commandLineUniqueID,
|  | int | timeoutMs = 0,
|  | int | streamFlags = ChildProcess::wantStdOut | ChildProcess::wantStdErr )

Attempts to launch and connect to a worker process. This will start the given executable, passing it a special command-line parameter based around the commandLineUniqueID string, which must be a short alphanumeric string (no spaces!) that identifies your app. The exe that gets launched must respond by calling ChildProcessWorker::initialiseFromCommandLine() in its startup code, and must use a matching ID to commandLineUniqueID.

The timeoutMs parameter lets you specify how long the child process is allowed to go without sending a ping before it is considered to have died and handleConnectionLost() will be called. Passing <= 0 for this timeout makes it use a default value.

If this all works, the method returns true, and you can begin sending and receiving messages with the worker process.

If a child process is already running, this will call killWorkerProcess() and start a new one.

Definition at line 156 of file juce_ConnectedChildProcess.cpp.

Referenced by ChildProcessCoordinator().

## sendMessageToSlave()

bool juce::ChildProcessCoordinator::sendMessageToSlave | ( | const MemoryBlock & | mb | ) |

inline

Definition at line 215 of file juce_ConnectedChildProcess.h.

## sendMessageToWorker()

bool juce::ChildProcessCoordinator::sendMessageToWorker | ( | const MemoryBlock & | mb | ) |

Attempts to send a message to the worker process. This returns true if the message was dispatched, but doesn't check that it actually gets delivered at the other end. If successful, the data will emerge in a call to your ChildProcessWorker::handleMessageFromCoordinator().

Definition at line 147 of file juce_ConnectedChildProcess.cpp.

Referenced by killWorkerProcess(), and launchWorkerProcess().

The documentation for this class was generated from the following files:

- juce_ConnectedChildProcess.h
- juce_ConnectedChildProcess.cpp